      SUBROUTINE AER2D(NM,N,MB,A,D,E,E2,MATZ,Z)
      DIMENSION A(NM,MB),D(N),E(N),E2(N),Z(NM,N)
      INTEGER NM,N,MB,J,K,L,R,I1,I2,J1,J2,KR,MR,M1,N2,R1,
     1UGL,MAXL,MAXR,MAX0,MIN0,MOD
      DOUBLE PRECISION A,D,E,E2,Z,G,U,B1,B2,C2,F1,F2,S2,DMIN,DMINRT,
     *DSQRT
      LOGICAL MATZ
      DMIN=2.D0**(-64)
      DMINRT=2.D0**(-32)
C     **********
      DO 1 J=1,N
    1 D(J)=1.D0
      IF(.NOT.MATZ) GO TO 4
      DO 3 J=1,N
      DO 2 K=1,N
    2 Z(J,K)=0.D0
      Z(J,J)=1.D0
    3 CONTINUE
    4 M1=MB-1
      IF(M1-1) 30,24,5
    5 N2=N-2
      DO 23 K=1,N2
      MAXR=MIN0(M1,N-K)
C     **********
      DO 16 R1=2,MAXR
      R=MAXR+2-R1
      KR=K+R
      MR=MB-R
      G=A(KR,MR)
      A(KR-1,1)=A(KR-1,MR+1)
      UGL=K
      DO 15 J=KR,N,M1
      J1=J-1
      J2=J1-1
      IF(G.EQ.0.D0) GO TO 16
      B1=A(J1,1)/G
      B2=B1*D(J1)/D(J)
      S2=1.D0/(1.D0+B1*B2)
      IF(S2.GE.0.5D0) GO TO 10
      B1=G/A(J1,1)
      B2=B1*D(J)/D(J1)
      C2=1.D0-S2
      D(J1)=C2*D(J1)
      D(J)=C2*D(J)
      F1=2.D0*A(J,M1)
      F2=B1*A(J1,MB)
      A(J,M1)=-B2*(B1*A(J,M1)-A(J,MB))-F2+A(J,M1)
      A(J1,MB)=B2*(B2*A(J,MB)+F1)+A(J1,MB)
      A(J,MB)=B1*(F2-F1)+A(J,MB)
      DO 6 L=UGL,J2
      I2=MB-J+L
      U=A(J1,I2+1)+B2*A(J,I2)
      A(J,I2)=-B1*A(J1,I2+1)+A(J,I2)
      A(J1,I2+1)=U
    6 CONTINUE
      UGL=J
      A(J1,1)=A(J1,1)+B2*G
      IF(J.EQ.N) GO TO 8
      MAXL=MIN0(M1,N-J1)
      DO 7 L=2,MAXL
      I1=J1+L
      I2=MB-L
      U=A(I1,I2)+B2*A(I1,I2+1)
      A(I1,I2+1)=-B1*A(I1,I2)+A(I1,I2+1)
      A(I1,I2)=U
    7 CONTINUE
      I1=J+M1
      IF(I1.GT.N) GO TO 8
      G=B2*A(I1,1)
    8 IF(.NOT.MATZ) GO TO 15
      DO 9 L=1,N
      U=Z(L,J1)+B2*Z(L,J)
      Z(L,J)=-B1*Z(L,J1)+Z(L,J)
      Z(L,J1)=U
    9 CONTINUE
      GO TO 15
   10 U=D(J1)
      D(J1)=S2*D(J)
      D(J)=S2*U
      F1=2.D0*A(J,M1)
      F2=B1*A(J,MB)
      U=B1*(F2-F1)+A(J1,MB)
      A(J,M1)=B2*(B1*A(J,M1)-A(J1,MB))+F2-A(J,M1)
      A(J1,MB)=B2*(B2*A(J1,MB)+F1)+A(J,MB)
      A(J,MB)=U
      DO 11 L=UGL,J2
      I2=MB-J+L
      U=B2*A(J1,I2+1)+A(J,I2)
      A(J,I2)=-A(J1,I2+1)+B1*A(J,I2)
      A(J1,I2+1)=U
   11 CONTINUE
      UGL=J
      A(J1,1)=B2*A(J1,1)+G
      IF(J.EQ.N) GO TO 13
      MAXL=MIN0(M1,N-J1)
      DO 12 L=2,MAXL
      I1=J1+L
      I2=MB-L
      U=B2*A(I1,I2)+A(I1,I2+1)
      A(I1,I2+1)=-A(I1,I2)+B1*A(I1,I2+1)
      A(I1,I2)=U
   12 CONTINUE
      I1=J+M1
      IF(I1.GT.N) GO TO 13
      G=A(I1,1)
      A(I1,1)=B1*A(I1,1)
   13 IF(.NOT.MATZ) GO TO 15
      DO 14 L=1,N
      U=B2*Z(L,J1)+Z(L,J)
      Z(L,J)=-Z(L,J1)+B1*Z(L,J)
      Z(L,J1)=U
   14 CONTINUE
   15 CONTINUE
   16 CONTINUE
      IF(MOD(K,64).NE.0) GO TO 23
C     **********
      DO 22 J=K,N
      IF(D(J).GE.DMIN) GO TO 22
      MAXL=MAX0(1,MB+1-J)
      DO 17 L=MAXL,M1
   17 A(J,L)=DMINRT*A(J,L)
      IF(J.EQ.N) GO TO 19
      MAXL=MIN0(M1,N-J)
      DO 18 L=1,MAXL
      I1=J+L
      I2=MB-L
      A(I1,I2)=DMINRT*A(I1,I2)
   18 CONTINUE
   19 IF(.NOT.MATZ) GO TO 21
      DO 20 L=1,N
   20 Z(L,J)=DMINRT*Z(L,J)
   21 A(J,MB)=DMIN*A(J,MB)
      D(J)=D(J)/DMIN
   22 CONTINUE
   23 CONTINUE
C     **********
   24 DO 25 J=2,N
   25 E(J)=DSQRT(D(J))
      IF(.NOT.MATZ) GO TO 28
      DO 27 J=1,N
      DO 26 K=2,N
   26 Z(J,K)=E(K)*Z(J,K)
   27 CONTINUE
   28 U=1.D0
      DO 29 J=2,N
      A(J,M1)=U*E(J)*A(J,M1)
      U=E(J)
      E2(J)=A(J,M1)**2
      A(J,MB)=D(J)*A(J,MB)
      D(J)=A(J,MB)
      E(J)=A(J,M1)
   29 CONTINUE
      D(1)=A(1,MB)
      E(1)=0.D0
      E2(1)=0.D0
      GO TO 32
   30 DO 31 J=1,N
      D(J)=A(J,MB)
      E(J)=0.D0
      E2(J)=0.D0
   31 CONTINUE
   32 RETURN
      END
